
(******************************************************************************)
(*                                                                            *)
(*                                                                            *)
(*                             Reliability of                                 *)
(*                         a drive-by-wire system                             *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*loadPath := "/home/yassmeen/Downloads/Reqiured-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DFT-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DRBD-Theories" :: !loadPath;

*)
(*set_trace "Unicode" 0;*)




(*app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", 
"optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory",
"pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory",
"PIE_EXTREALTheory", "integration_before_afterTheory", "dep_rewrite", "DFT_Gates_def_PROBTheory",  "WCSPTheory",  "DRBDTheory", "SENplusTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory mesonLib 
boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory
normal_rv_hvgTheory netsTheory PIE_EXTREALTheory integration_before_afterTheory dep_rewrite DFT_Gates_def_PROBTheory  WCSPTheory   DRBDTheory SENplusTheory;

val _ = new_theory "DBW";



infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;




val DBW_set_req_def = Define `DBW_set_req p TF EF BCU PC SC_a SC_d TS BS t= indep_sets p
     (\i.
          {if i = 0 then DRBD_event p TF t
           else if i = 1 then DRBD_event p EF t
           else if i = 2 then DRBD_event p BCU t
           else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
           else if i = 4 then DRBD_event p TS t else DRBD_event p BS t})
     {0; 1; 2; 3; 4; 5}  /\ (!i. i:num IN {0;1;2;3;4;5} ==> (\i. if i:num = 0 then DRBD_event p TF t
           else if i = 1 then DRBD_event p EF t
           else if i = 2 then DRBD_event p BCU t
           else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
           else if i = 4 then DRBD_event p TS t else DRBD_event p BS t) i IN events  p)`;


val Rel_DBW = store_thm("Rel_DBW",
  `` !p TF EF BCU PC SC_a SC_d TS BS t.
  DBW_set_req p TF EF BCU PC SC_a SC_d TS BS t ==>

(prob p (DRBD_series (\i. if i = 0 then DRBD_event p TF t
	         else if i = 1 then DRBD_event p EF t
		 else if i = 2 then DRBD_event p BCU t
		 else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
		 else if i = 4 then DRBD_event p TS t
		 else DRBD_event p BS t) {0;1;2;3;4;5}) =
		 Rel p TF t * Rel p EF t * Rel p BCU t *
		 Rel p (WSP PC SC_a SC_d) t * Rel p TS t * Rel p BS t)``,

RW_TAC std_ss[DBW_set_req_def] THEN DEP_REWRITE_TAC[PROB_DRBD_series]
THEN RW_TAC std_ss[]
     THEN1 ASM_SET_TAC[FINITE_DEF]
     THEN1 ASM_SET_TAC[FINITE_DEF]

THEN `{0:num;1;2;3;4;5} = {0} UNION {1;2;3;4;5}` by ASM_SET_TAC[]
THEN `FINITE {0:num} /\ FINITE {1;2;3;4;5:num} /\ DISJOINT {0} {1;2;3;4;5:num}` by ASM_SET_TAC[FINITE_DEF]
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN `{1;2;3;4;5:num} = {1} UNION {2;3;4;5}` by ASM_SET_TAC[]
THEN `FINITE {1:num} /\ FINITE {2;3;4;5:num} /\ DISJOINT {1} {2;3;4;5:num}` by (SRW_TAC[][] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN `{2;3;4;5:num} = {2} UNION {3;4;5}` by ASM_SET_TAC[]
THEN `FINITE {2:num} /\ FINITE {3;4;5:num} /\ DISJOINT {2} {3;4;5:num}` by (SRW_TAC[][] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN `{3;4;5:num} = {3} UNION {4;5}` by ASM_SET_TAC[]
THEN `FINITE {3:num} /\ FINITE {4;5:num} /\ DISJOINT {3} {4;5:num}` by (SRW_TAC[][] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN `{4;5:num} = {4} UNION {5}` by ASM_SET_TAC[]
THEN `FINITE {4:num} /\ FINITE {5:num} /\ DISJOINT {4} {5:num}` by (SRW_TAC[][] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC std_ss[GSYM Rel_def]
THEN RW_TAC std_ss[REAL_MUL_ASSOC]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN NTAC 20 (POP_ASSUM K_TAC)
THEN `prob_space p`by FULL_SIMP_TAC std_ss[indep_sets]
THEN KNOW_TAC(``Rel p TF t <> PosInf /\ Rel p TF t <> NegInf ``)
    THEN1(REWRITE_TAC[Rel_def]
         THEN UNDISCH_TAC(``  !i:num.
             i IN {0; 1; 2; 3; 4; 5:num} ==>
             (if i:num = 0 then DRBD_event p (TF:'a->extreal) t
              else if i = 1 then DRBD_event p EF t
              else if i = 2 then DRBD_event p BCU t
              else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
              else if i = 4 then DRBD_event p TS t
              else DRBD_event p BS t) IN events p ``)
	 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)     
         THEN DISCH_TAC THEN `0:num IN {0;1;2;3;4;5}` by ASM_SET_TAC[]
	 THEN FULL_SIMP_TAC std_ss[]
         THEN METIS_TAC[PROB_FINITE, indep_sets])
	 
THEN KNOW_TAC(``Rel p EF t <> PosInf /\ Rel p EF t <> NegInf ``)
    THEN1(REWRITE_TAC[Rel_def]
         THEN UNDISCH_TAC(``  !i:num.
             i IN {0; 1; 2; 3; 4; 5:num} ==>
             (if i:num = 0 then DRBD_event p (TF:'a->extreal) t
              else if i = 1 then DRBD_event p EF t
              else if i = 2 then DRBD_event p BCU t
              else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
              else if i = 4 then DRBD_event p TS t
              else DRBD_event p BS t) IN events p ``)
	 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num`)     
         THEN DISCH_TAC THEN `1:num IN {0;1;2;3;4;5}` by ASM_SET_TAC[]
	 THEN FULL_SIMP_TAC std_ss[]
         THEN METIS_TAC[PROB_FINITE, indep_sets])
	 
THEN KNOW_TAC(``Rel p BCU t <> PosInf /\ Rel p BCU t <> NegInf ``)
    THEN1(REWRITE_TAC[Rel_def]
         THEN UNDISCH_TAC(``  !i:num.
             i IN {0; 1; 2; 3; 4; 5:num} ==>
             (if i:num = 0 then DRBD_event p (TF:'a->extreal) t
              else if i = 1 then DRBD_event p EF t
              else if i = 2 then DRBD_event p BCU t
              else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
              else if i = 4 then DRBD_event p TS t
              else DRBD_event p BS t) IN events p ``)
	 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num`)     
         THEN DISCH_TAC THEN `2:num IN {0;1;2;3;4;5}` by ASM_SET_TAC[]
	 THEN FULL_SIMP_TAC std_ss[]
         THEN METIS_TAC[PROB_FINITE, indep_sets])
	 
	 
THEN KNOW_TAC(``Rel p (WSP PC SC_a SC_d) t <> PosInf /\ Rel p (WSP PC SC_a SC_d) t <> NegInf ``)
    THEN1(REWRITE_TAC[Rel_def]
         THEN UNDISCH_TAC(``  !i:num.
             i IN {0; 1; 2; 3; 4; 5:num} ==>
             (if i:num = 0 then DRBD_event p (TF:'a->extreal) t
              else if i = 1 then DRBD_event p EF t
              else if i = 2 then DRBD_event p BCU t
              else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
              else if i = 4 then DRBD_event p TS t
              else DRBD_event p BS t) IN events p ``)
	 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num`)     
         THEN DISCH_TAC THEN `3:num IN {0;1;2;3;4;5}` by ASM_SET_TAC[]
	 THEN FULL_SIMP_TAC std_ss[]
         THEN METIS_TAC[PROB_FINITE, indep_sets])

	 
THEN KNOW_TAC(``Rel p TS t <> PosInf /\ Rel p TS t <> NegInf ``)
    THEN1(REWRITE_TAC[Rel_def]
         THEN UNDISCH_TAC(``  !i:num.
             i IN {0; 1; 2; 3; 4; 5:num} ==>
             (if i:num = 0 then DRBD_event p (TF:'a->extreal) t
              else if i = 1 then DRBD_event p EF t
              else if i = 2 then DRBD_event p BCU t
              else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
              else if i = 4 then DRBD_event p TS t
              else DRBD_event p BS t) IN events p ``)
	 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4:num`)     
         THEN DISCH_TAC THEN `4:num IN {0;1;2;3;4;5}` by ASM_SET_TAC[]
	 THEN FULL_SIMP_TAC std_ss[]
         THEN METIS_TAC[PROB_FINITE, indep_sets])

	 
THEN KNOW_TAC(``Rel p BS t <> PosInf /\ Rel p BS t <> NegInf ``)
    THEN1(REWRITE_TAC[Rel_def]
         THEN UNDISCH_TAC(``  !i:num.
             i IN {0; 1; 2; 3; 4; 5:num} ==>
             (if i:num = 0 then DRBD_event p (TF:'a->extreal) t
              else if i = 1 then DRBD_event p EF t
              else if i = 2 then DRBD_event p BCU t
              else if i = 3 then DRBD_event p (WSP PC SC_a SC_d) t
              else if i = 4 then DRBD_event p TS t
              else DRBD_event p BS t) IN events p ``)
	 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5:num`)     
         THEN DISCH_TAC THEN `5:num IN {0;1;2;3;4;5}` by ASM_SET_TAC[]
	 THEN FULL_SIMP_TAC std_ss[]
         THEN METIS_TAC[PROB_FINITE, indep_sets])



THEN RW_TAC std_ss[normal_real]);


val _ = export_theory();

