
(******************************************************************************)
(*                                                                            *)
(*                                                                            *)
(*                       Terminal Reliability of                              *)
(*                       Shuffle-exchange Network                             *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*loadPath := "/home/yassmeen/Downloads/Reqiured-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DFT-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DRBD-Theories" :: !loadPath;

*)
(*set_trace "Unicode" 0;*)




(*app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", 
"optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory",
"pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory",
"PIE_EXTREALTheory", "integration_before_afterTheory", "dep_rewrite", "DFT_Gates_def_PROBTheory",  "WCSPTheory",  "DRBDTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory mesonLib 
boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory
normal_rv_hvgTheory netsTheory PIE_EXTREALTheory integration_before_afterTheory dep_rewrite DFT_Gates_def_PROBTheory  WCSPTheory   DRBDTheory ;

val _ = new_theory "SENplus";



infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;



(******************************************************************************)
(*                                                                            *)
(*                          some extreal numbers properties                   *)
(*                                                                            *)
(******************************************************************************)


val normal_real_mul1 = store_thm("normal_real_mul1",
  ``  !a b c.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (Normal (real a * real b * c) = a * b * Normal c)``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]);


val normal_real_mul2 = store_thm("normal_real_mul2",
  ``    !a b c d.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (Normal (real a * c * d * real b) = a * b * Normal (c * d)) ``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]
THEN METIS_TAC[REAL_MUL_ASSOC, REAL_MUL_COMM]);


val normal_real_mul3 = store_thm("normal_real_mul3",
  `` !a b c.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (Normal (real a * c * real b) = a * b * Normal c)``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]
THEN METIS_TAC[REAL_MUL_ASSOC, REAL_MUL_COMM]);

val real_mul_real = store_thm("real_mul_real",
  ``!a b.
        a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b<> NegInf ==>
        (real a * real b = real (a * b))  ``,
RW_TAC std_ss[real_def]
THEN RW_TAC std_ss[REAL_MUL_LZERO] 
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(Q.EXISTS_TAC`real a`
           THEN METIS_TAC[normal_real])
     THEN1(SELECT_ELIM_TAC
           THEN RW_TAC std_ss[]
                THEN1 (Q.EXISTS_TAC`real b`
                       THEN METIS_TAC[normal_real])
           THEN FULL_SIMP_TAC std_ss[extreal_mul_def]      
           THEN METIS_TAC[extreal_not_infty])
     THEN1(Q.EXISTS_TAC`real a`
           THEN METIS_TAC[normal_real])          
     THEN1(SELECT_ELIM_TAC
           THEN RW_TAC std_ss[]
                THEN1 (Q.EXISTS_TAC`real b`
                       THEN METIS_TAC[normal_real])
           THEN FULL_SIMP_TAC std_ss[extreal_mul_def]      
           THEN METIS_TAC[extreal_not_infty])
    THEN1(Q.EXISTS_TAC`real a`
           THEN METIS_TAC[normal_real])          
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1 (Q.EXISTS_TAC`real b`
            THEN METIS_TAC[normal_real])
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
      THEN1(RW_TAC std_ss[extreal_mul_def])
THEN FULL_SIMP_TAC std_ss[extreal_mul_def]
THEN RW_TAC std_ss[] );
    	   

val extreal_sub_sub2 = store_thm("extreal_sub_sub2",
  ``   !a b.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (a - (a - b) = b)  ``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[extreal_sub_def]
THEN METIS_TAC[REAL_SUB_SUB2]);



(******************************************************************************)
(*                          event set                                         *)
(*                                                                            *)
(*                                                                            *)
(******************************************************************************)

val event_set1_def = Define `event_set1 (X,i) Y = (\j. if j = i then X else Y j)  `;

val event_set2_def = Define `event_set2 (X1, i1) (X2, i2) Y =
                             event_set1 X1 i1 (event_set1 X2 i2 Y)  `;


val event_set_def = Define `(event_set [(X1,i1)] Y  = event_set1 (X1,i1) Y) /\
                            (event_set ((X1,i1)::t) Y = event_set1 (X1,i1) (event_set t Y))`;

val ind_set_def = Define `ind_set A = (\i. EL i A)  `;



(******************************************************************************)
(*                                                                            *)
(*                      Reliability of SEN+                                   *)
(*                                                                            *)
(******************************************************************************)


val DISJOINT3_def = Define `DISJOINT3 L1 L2 L3 =
                            DISJOINT L1 L2 /\ DISJOINT L1 L3 /\ DISJOINT L2 L3`;

val PROB_DRBD_SEN_plus_lem1 = store_thm("PROB_DRBD_SEN_plus_lem1",
  `` !p X L1 L2 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l. l IN BIGUNION_o_BIGUNION L A J ==> X l IN events p) /\
            indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (DRBD_series
                  (\j. DRBD_parallel (\a. DRBD_series X (L a)) (A j)) J) =
             prob p (X 0) * prob p (X 3) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,
    
RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT3 {0;3:num} L1 L2 ``)
     THEN1(RW_TAC std_ss[DISJOINT3_def]
           THEN1( FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN KNOW_TAC(`` {0:num} INTER L1 = {}``)
    	              THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	                   THEN DISCH_TAC
	              	   THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      	   THEN RW_TAC list_ss[])
	         THEN DISCH_TAC	       
                 THEN KNOW_TAC(`` {3:num} INTER L1 = {}``)
    	              THEN1(POP_ASSUM MP_TAC
		            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	              	    THEN DISCH_TAC
	              	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      	    THEN RW_TAC list_ss[])
	         THEN DISCH_TAC THEN ASM_SET_TAC[DISJOINT_DEF])
	    THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN KNOW_TAC(`` {0:num} INTER L2 = {}``)
    	              THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	                   THEN DISCH_TAC
	              	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      	   THEN RW_TAC list_ss[])
	         THEN DISCH_TAC	       
                 THEN KNOW_TAC(`` {3:num} INTER L2 = {}``)
    	              THEN1(POP_ASSUM MP_TAC
		            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	              	    THEN DISCH_TAC
	              	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      	    THEN RW_TAC list_ss[])
	         THEN DISCH_TAC THEN ASM_SET_TAC[DISJOINT_DEF])
	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN DISCH_TAC
	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
     	    THEN RW_TAC list_ss[]
	    THEN FULL_SIMP_TAC list_ss[ind_set_def]
	    THEN ASM_SET_TAC[DISJOINT_DEF])
THEN RW_TAC std_ss[DISJOINT3_def]
THEN KNOW_TAC(``BIGUNION {EL j [{0:num}; {1; 2}; {3}] | j IN {0; 1; 2:num}} = {0;1;2;3} ``)
     THEN1( SRW_TAC[][GSPECIFICATION, EXTENSION]
            THEN EQ_TAC
                THEN1(RW_TAC std_ss[]
      		      THEN FULL_SIMP_TAC list_ss[])
         	 THEN RW_TAC std_ss[]
		      THEN1( Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[] 
	                    THEN Q.EXISTS_TAC`0` THEN RW_TAC std_ss[]
			    THEN RW_TAC list_ss[])
	 	      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	                    THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
	   	            THEN RW_TAC list_ss[])
		      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		             THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
		             THEN RW_TAC list_ss[])
           THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
     	   THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[PROB_DRBD_series_parallel_series_lem]
THEN RW_TAC std_ss[]
     THEN1 ASM_SET_TAC[]
     THEN1 ASM_SET_TAC[]
     THEN1 (RW_TAC std_ss[sets_finite_not_empty2_def]
            THEN1(RW_TAC std_ss[ind_set_def]
	          THEN `(j=0:num) \/(j=1) \/(j=2)` by ASM_SET_TAC[]
		  THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
            THEN1(RW_TAC std_ss[ind_set_def]
	          THEN `(j=0:num) \/(j=1) \/(j=2)` by ASM_SET_TAC[]
	               THEN1( RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		       THEN1(RW_TAC list_ss[] THEN `{1:num;2} = {1} UNION {2}` by ASM_SET_TAC[]
		            THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
		  THEN RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
 	    THEN1( RW_TAC std_ss [ind_set_def]
	           THEN FULL_SIMP_TAC std_ss[ind_set_def]
		   THEN`(a:num = 0) \/ (a = 1) \/ (a = 2) \/ (a = 3)` by ASM_SET_TAC[]
		   THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	    THEN1(RW_TAC std_ss[ind_set_def] THEN FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN `(a:num = 0) \/ (a = 1) \/ (a = 2) \/ (a = 3)` by ASM_SET_TAC[]
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(RW_TAC list_ss[])
		      THEN1(RW_TAC list_ss[])
		 THEN RW_TAC list_ss[]  THEN ASM_SET_TAC[FINITE_SING])
	    THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
	          THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
            THEN1( RW_TAC std_ss[ind_set_def] THEN RW_TAC std_ss[disjoint_family_on]
	         THEN `((j = 0:num) \/ (j = 1) \/ (j=2)) /\ ((j'=0:num) \/ (j'=1)\/(j'=2))` by ASM_SET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	              THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	              THEN1(FULL_SIMP_TAC std_ss[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	          THEN FULL_SIMP_TAC std_ss[])
            THEN1(ASM_SET_TAC[])
            THEN RW_TAC std_ss[disjoint_family_on, ind_set_def]	            
            THEN PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
THEN `{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[]		 
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``FINITE {0:num} /\ FINITE {1;2:num} /\ DISJOINT {0:num} {1;2}``)
     THEN1(RW_TAC std_ss[FINITE_SING]
         THEN1(`{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
            THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
     THEN ASM_SET_TAC[DISJOINT_DEF])	    
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN RW_TAC std_ss[PRODUCT_SING]
THEN KNOW_TAC(``ind_set [{0}; {1; 2}; {3}] 0 = {0} ``)
    THEN1(RW_TAC std_ss[ind_set_def]
          THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]	  
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``
      real
        (1 -
         Normal(product (ind_set [{0}; {1; 2}; {3}] 0)
              (\a.
                   real
                     (1 -
                      Normal
                        (product (ind_set [{0}; (L1:num->bool); L2; {3}] a)
                           (\l. real (1 - Normal (real (1 - prob p (X l)))))))))) =
     real (1-Normal (real (1 - Normal (real (1 - Normal (real (1 - prob p (X 0))))))) ) ``)

    THEN1(NTAC 3(AP_TERM_TAC)
          THEN ONCE_ASM_REWRITE_TAC[]
	  THEN KNOW_TAC(`` product (ind_set [{0}; {1; 2}; {3}] 0)
     (\a.
          real
            (1 -
             Normal
               (product (ind_set [{0}; L1; L2; {3:num}] a)
                  (\l. real (1 - Normal (real (1 - prob p (X l))))))))  =
		   product ({0})
     (\a.
          real
            (1 -
             Normal
               (product (ind_set [{0}; L1; L2; {3}] a)
                  (\l. real (1 - Normal (real (1 - prob p (X l))))))))``)
	      THEN1(RW_TAC std_ss[ind_set_def] THEN RW_TAC list_ss[])
	  THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]    
	  THEN RW_TAC std_ss[PRODUCT_SING]
	  THEN RW_TAC std_ss[ind_set_def]
          THEN RW_TAC list_ss[]
	  THEN RW_TAC std_ss[PRODUCT_SING])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	  
THEN `({1:num;2} = {1} UNION {2}) /\ FINITE {1:num} /\ FINITE {2:num} /\ DISJOINT {1:num}{2}` by ASM_SET_TAC[FINITE_SING, DISJOINT_DEF]
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC list_ss[ind_set_def, PRODUCT_SING]
THEN KNOW_TAC(``
      real
         (1 -
          Normal
            (product ({1} UNION {2})
               (\a.
                    real
                      (1 -
                       Normal
                         (product (EL a [{0}; L1; L2; {3:num}])
                            (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))))))) =
       real
          (1 -
           Normal
             (real
                (1 -
                 Normal
                   (product L1
                      (\l. real (1 - Normal (real (1 - prob p (X l))))))) *
              real
                (1 -
                 Normal
                   (product L2
                      (\l. real (1 - Normal (real (1 - prob p (X l)))))))))``)
     THEN1(NTAC 3(AP_TERM_TAC)
           THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
	   THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]	   
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
     THEN1(KNOW_TAC(`` 0:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         THEN Q.EXISTS_TAC`{0}`
	         THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	 	 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[])
		 THEN DISCH_TAC THEN `(X:num->'a->bool) 0 IN events p` by ASM_SET_TAC[]
		 THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
THEN `1 <> PosInf /\ 1 <> NegInf` by METIS_TAC[extreal_of_num_def, extreal_not_infty]
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 3) <> PosInf /\ prob p (X 3) <> NegInf ``)
     THEN1(KNOW_TAC(`` 3:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN Q.EXISTS_TAC`{3}`
		 THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		 THEN Q.EXISTS_TAC`3` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
	   THEN DISCH_TAC	 
	   THEN  `(X:num->'a->bool) 3 IN events p` by ASM_SET_TAC[]
	   THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
	   THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
	   	 
THEN KNOW_TAC(`` 
     (real
        (1 -
         Normal
           (real (1 - Normal (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) 0))))))))) =
	   real (prob p (X 0)) ``)
      THEN1(AP_TERM_TAC
	    THEN KNOW_TAC(`` Normal (real (1 - prob p ((X:num->'a->bool) 0))) = 1-prob p (X 0) ``)
                 THEN1(METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	    THEN KNOW_TAC(``(1 - (1 - prob p (X 0))) = prob p ((X:num->'a->bool) 0) ``)
		THEN1(METIS_TAC[extreal_sub_sub2])
	    THEN RW_TAC std_ss[]
	    THEN RW_TAC std_ss[normal_real])
THEN RW_TAC std_ss[]	    
THEN KNOW_TAC(``
       real
          (1 -
          Normal
            (real (1 - Normal (real (1 - Normal (real (1 - prob p (X 3)))))))) =
      real (prob p ((X:num->'a->bool) 3))``)
      THEN1( KNOW_TAC(`` Normal (real (1 - prob p (X 3))) = (1-prob p ((X:num->'a->bool) 3)) ``) 
	        THEN1 METIS_TAC[sub_not_infty, normal_real]
	   THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	   THEN KNOW_TAC(``(1 - (1 - prob p (X 3))) = prob p ((X:num->'a->bool) 3) ``)
		THEN1(METIS_TAC[extreal_sub_sub2])
	    THEN RW_TAC std_ss[]
	    THEN RW_TAC std_ss[normal_real])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[REAL_MUL_ASSOC]
THEN RW_TAC std_ss[normal_real_mul3]
THEN KNOW_TAC(``(product L1
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L1
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
          !l:num.
	     l IN L1 ==> (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
             real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L1`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[])
		 	     THEN DISCH_TAC THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	    
THEN KNOW_TAC(``(product L2
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L2
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
            !l:num.
	      l IN L2 ==>
	      (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
               real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L2`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[])
		 	     THEN DISCH_TAC THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]
THEN `(1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
      (1 − Normal (product L1 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN  `(1 − Normal (product L2 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
       (1 − Normal (product L2 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN RW_TAC std_ss[real_mul_real]
THEN `((1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) *
               (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> PosInf /\
	       ((1 − Normal (product L1 (λl. real (prob p (X l))))) *
               (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> NegInf` by METIS_TAC[mul_extreal_not_infty]
THEN RW_TAC std_ss[normal_real]
THEN `(1 −
         (1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) *
         (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> PosInf /\
      (1 −
         (1 − Normal (product L1 (λl. real (prob p (X l))))) *
         (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> NegInf` by METIS_TAC[sub_not_infty]THEN RW_TAC std_ss[normal_real]);	 


val PROB_DRBD_SEN_plus = store_thm("PROB_DRBD_SEN_plus",
  `` !p X Y Z t L1 L2 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l.
                 l IN BIGUNION_o_BIGUNION L A J ==>
                 event_set [(DRBD_event p Y t,0); (DRBD_event p Z t,3)] X l IN
                 events p) /\
            indep_sets p
              (\i.
                   {event_set [(DRBD_event p Y t,0); (DRBD_event p Z t,3)] X
                      i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p Y t,0);
                                        (DRBD_event p Z t,3)] X i) (L a))
                         (A j)) J) =
             prob p (DRBD_event p Y t) * prob p (DRBD_event p Z t) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,

RW_TAC std_ss[event_set_def, event_set1_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus_lem1]
THEN RW_TAC std_ss[]
     THEN1 ASM_SET_TAC[ETA_THM]
     THEN1 (UNDISCH_TAC(`` !l:num.
             l IN
             BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2} ==>
             (if l = 0 then DRBD_event p Y t
              else if l = 3 then DRBD_event p Z t
              else X l) IN events p``)
	    THEN DISCH_TAC   
	    THEN POP_ASSUM (MP_TAC o Q.ISPEC`3:num`)
	    THEN RW_TAC std_ss[]
	    THEN METIS_TAC[ETA_THM])
    THEN1 ASM_SET_TAC[ETA_THM]
    THEN1 ASM_SET_TAC[ETA_THM]
    THEN1 ASM_SET_TAC[ETA_THM]
    THEN1 ASM_SET_TAC[ETA_THM]
THEN RW_TAC std_ss[]    
THEN KNOW_TAC(``{0:num} INTER L1 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	    THEN RW_TAC list_ss[])
THEN KNOW_TAC(``{3:num} INTER L1 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	    THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` !i:num. i IN L1 ==>
                (real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else (X:num->'a->bool) i)) =
		 real (prob p (X i))) ``)
      THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     (1 -
     Normal
       (product L1
          (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else (X:num->'a->bool) i))))) =

     (1 -
     Normal
       (product L1
          (\i.
               real
                 (prob p
                     (X i)))))``)
      THEN1 (NTAC 2(AP_TERM_TAC) THEN  RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]      
THEN KNOW_TAC(``{0:num} INTER L2 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN UNDISCH_TAC (``!m n:num.
             m IN {0; 1; 2; 3} /\ n IN {0; 1; 2; 3} /\ m <> n ==>
             (EL m [{0:num}; L1; L2; {3}] INTER EL n [{0}; L1; L2; {3}] = {})``)
	    THEN DISCH_TAC
 	    THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN RW_TAC list_ss[])
THEN DISCH_TAC	    
THEN KNOW_TAC(``{3:num} INTER L2 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
     	    THEN UNDISCH_TAC (``!m n:num.
             m IN {0; 1; 2; 3} /\ n IN {0; 1; 2; 3} /\ m <> n ==>
             (EL m [{0:num}; L1; L2; {3}] INTER EL n [{0}; L1; L2; {3}] = {})``)
	    THEN DISCH_TAC
 	    THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i. i IN L2 ==> (

                 real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else X i)) =
		 real (prob p ((X:num->'a->bool) i)))``)

       THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN DISCH_TAC
THEN KNOW_TAC(``
        product L2
             (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else X i))) =
       (product L2 (\l. real (prob p ((X:num->'a->bool) l))))  ``)
       THEN1(RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]       
THEN RW_TAC std_ss[]);

val PROB_DRBD_SEN_plus_rel_lem = store_thm("PROB_DRBD_SEN_plus_rel_lem",
  ``  !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l.
                 l IN BIGUNION_o_BIGUNION L A J ==>
                 event_set
                   [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                    (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] X l IN events p) /\
            indep_sets p
              (\i.
                   {event_set
                      [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                       (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] X i})
              (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                                        (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                                       X i) (L a)) (A j)) J) =
             Rel p (R_WSP Y Ys_a Ys_d) t * Rel p (R_WSP Z Zs_a Zs_d) t *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,

RW_TAC std_ss[Rel_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus]
THEN METIS_TAC[ETA_THM]);


val SEN_set_req_def = Define `SEN_set_req p L1 L2 L A J X =
L1 <> {} /\ (L2:num->bool) <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l.
                 l IN BIGUNION_o_BIGUNION L A J ==>
                 X l IN events p) /\
            indep_sets p
              (\i. {X i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0:num; 1; 2; 3}`;


val PROB_DRBD_SEN_plus_rel = store_thm("PROB_DRBD_SEN_plus_rel",
  `` !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2 L A J.
            SEN_set_req p L1 L2 (ind_set [{0:num}; L1; L2; {3}])
	         (ind_set [{0}; {1:num; 2}; {3}]){0;1;2} (event_set
                   [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                    (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                   (rv_to_event p X t))  ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                                        (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                                       (rv_to_event p X t) i)
                                (ind_set [{0}; L1; L2; {3}] a))
                         (ind_set [{0}; {1; 2}; {3}] j)) {0; 1; 2}) =
             Rel p (R_WSP Y Ys_a Ys_d) t * Rel p (R_WSP Z Zs_a Zs_d) t *
             (1 -
              (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
              (1 - Normal (product L2 (\l. real (Rel p (X l) t))))))``,

RW_TAC std_ss[Rel_def, PROB_DRBD_SEN_plus, rv_to_event_def, SEN_set_req_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus]
THEN METIS_TAC[ETA_THM]);


val SEN_nR_AND = store_thm("SEN_nR_AND",
  ``!p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2.
        DISJOINT3 {0; 3} L1 L2  /\
        FINITE L1 /\ FINITE L2 /\ L1 <> {} /\ L2 <> {} ==>
        ( DRBD_event p
           (nR_AND
              (\i.
                   if i = 0 then R_WSP Y Ys_a Ys_d
                   else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                   else R_WSP Z Zs_a Zs_d) {0; 1; 2:num}) t =
	  DRBD_series
           (\j.
                DRBD_parallel
                  (\a.
                       DRBD_series
                         (\i.
                              event_set
                                [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                                 (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                                (rv_to_event p X t) i)
                         (ind_set [{0}; L1; L2; {3}] a))
                  (ind_set [{0}; {1; 2}; {3}] j)) {0; 1; 2})``,


RW_TAC std_ss[DISJOINT3_def]
THEN `{0;1;2:num} <>{}` by ASM_SET_TAC[]
THEN KNOW_TAC(``FINITE {0;1;2:num} ``)
     THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
              THEN ONCE_ASM_REWRITE_TAC[]
	      THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING])
THEN DISCH_TAC
THEN KNOW_TAC(``
   DRBD_event p
     (nR_AND
        (\i.
             if i = 0:num then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
             else R_WSP Z Zs_a Zs_d) {0; 1; 2}) t =
   DRBD_series
     (rv_to_event p 
        (\i:num.
             if i = 0 then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))
             else R_WSP Z Zs_a Zs_d) t) {0; 1; 2:num} ``)

      THEN1 RW_TAC std_ss[nR_AND_DRBD_series]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
    DRBD_series
     (rv_to_event p
        (\i.
             if i = 0 then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))
             else R_WSP Z Zs_a Zs_d) t) {0; 1; 2}=
    DRBD_event p (R_WSP Y Ys_a Ys_d) t INTER
    DRBD_event p (R_OR (nR_AND X L1) (nR_AND X L2)) t INTER
    DRBD_event p (R_WSP Z Zs_a Zs_d) t ``)
     THEN1(RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
           THEN KNOW_TAC(``
     {DRBD_event p
       (if i:num = 0 then R_WSP Y Ys_a Ys_d
        else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
        else R_WSP Z Zs_a Zs_d) t |
     i IN {0; 1; 2}} =
     {DRBD_event p
       (R_WSP Y Ys_a Ys_d) t;
      DRBD_event p (R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))) t;
      DRBD_event p ( R_WSP Z Zs_a Zs_d) t}``)
              THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
 	 	    THEN Q.EXISTS_TAC`2`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[BIGINTER_3_sets])
THEN RW_TAC std_ss[]
THEN ASM_REWRITE_TAC[]
THEN ONCE_REWRITE_TAC[DRBD_series_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
    {DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1:num; 2}; {3}] i) |
     (i = 0) \/ (i = 1) \/ (i = 2)} =
     {DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3}] 0);
      DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3}] 1);
      DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3:num}] 2)}``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGINTER_3_sets]
THEN RW_TAC list_ss[ind_set_def, EL, HD]
THEN RW_TAC std_ss[DRBD_parallel_def]
THEN KNOW_TAC(``
    !k:num.
      {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL a [{0}; L1; L2; {3}]) |
     a = k}=
       {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL k [{0}; L1; L2; {3}])}``)

      THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[EL]
THEN RW_TAC std_ss[BIGUNION_SING]
THEN KNOW_TAC(``{DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL a [{0}; L1; L2; {3}]) |
     (a = 1) \/ (a = 2:num)} =
     {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL 1 [{0}; L1; L2; {3}]) ;
       DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL 2 [{0}; L1; L2; {3}])}``)
        THEN1(ASM_SET_TAC[])
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[BIGUNION_PAIR]
THEN RW_TAC std_ss[DRBD_parallel_def, DRBD_series_def, event_set_def, event_set1_def, ind_set_def, EL, rv_to_event_def]
THEN KNOW_TAC(``{if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
     else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
     else DRBD_event p (X i) t |
     i IN {0}} = { DRBD_event p (R_WSP Y Ys_a Ys_d) t} ``)

    THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
      else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
      else DRBD_event p (X i) t |
      i IN L1} =
      {DRBD_event p (X i) t |
      i IN L1}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
     {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
      else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
      else DRBD_event p (X i) t |
      i IN L2} =
      {DRBD_event p (X i) t |
      i IN L2}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
    {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
     else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
     else DRBD_event p (X i) t |
     i IN {3}} =
     {DRBD_event p (R_WSP Z Zs_a Zs_d) t}``)
    THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGINTER_SING]
THEN RW_TAC std_ss[R_OR_UNION] 
THEN RW_TAC std_ss[nR_AND_DRBD_series, DRBD_series_def]
THEN RW_TAC std_ss[rv_to_event_def]);



val Rel_DRBD_SEN_plus = store_thm("Rel_DRBD_SEN_plus",
  ``!p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2.
            SEN_set_req p L1 L2 (ind_set [{0}; L1; L2; {3}])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (event_set
               [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t)) ==>
          (prob p
             (DRBD_event p
             (nR_AND
                (\i.
                     if i:num = 0 then R_WSP Y Ys_a Ys_d
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else R_WSP Z Zs_a Zs_d) {0:num; 1; 2}) t) =
           Rel p (R_WSP Y Ys_a Ys_d) t * Rel p (R_WSP Z Zs_a Zs_d) t *
           (1 -
            (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))))) ``,


RW_TAC std_ss[SEN_set_req_def]
THEN DEP_REWRITE_TAC[GSYM PROB_DRBD_SEN_plus_rel]
THEN REWRITE_TAC[SEN_set_req_def]
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[GSYM SEN_nR_AND]
THEN RW_TAC std_ss[DISJOINT3_def]
     THEN1 (FULL_SIMP_TAC std_ss[ind_set_def]
            THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
 	    THEN KNOW_TAC(``{0:num} INTER L1 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      THEN FULL_SIMP_TAC list_ss[])
            THEN KNOW_TAC(``{3:num} INTER L1 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
		      THEN FULL_SIMP_TAC list_ss[INTER_COMM])
            THEN ASM_SET_TAC[disjoint_family_on, ind_set_def, EL])
      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
            THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
 	    THEN KNOW_TAC(``{0:num} INTER L2 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      THEN FULL_SIMP_TAC list_ss[])
            THEN KNOW_TAC(``{3:num} INTER L2 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
		      THEN FULL_SIMP_TAC list_ss[INTER_COMM])
            THEN ASM_SET_TAC[disjoint_family_on, ind_set_def, EL])
THEN FULL_SIMP_TAC std_ss[ind_set_def]
THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
THEN DISCH_TAC
THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
THEN FULL_SIMP_TAC list_ss[]
THEN ASM_SET_TAC[]);



val Rel_DRBD_SEN_plus1 = store_thm("Rel_DRBD_SEN_plus1",
  ``!p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2 f_y f_z f_condY f_condZ f_ysy f_zsz.
            SEN_set_req p L1 L2 (ind_set [{0}; L1; L2; {3}])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (event_set
               [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t)) /\
            prob_space p /\ (!s. ALL_DISTINCT [Ys_a s; Ys_d s; Y s; Zs_a s; Zs_d s; Z s]) /\
         DISJOINT_WSP Y Ys_a Ys_d t /\ DISJOINT_WSP Z Zs_a Zs_d t /\
         rv_gt0_ninfinity [Ys_a; Ys_d; Y; Zs_a; Zs_d; Z] /\
         0 <= t /\
         (!y.
              cond_density lborel lborel p (real o Ys_a) (real o Y) y f_ysy
                f_y f_condY) /\ den_gt0_ninfinity f_ysy f_y f_condY /\
         indep_var p lborel (real o Ys_d) lborel (real o Y) /\
         cont_CDF p (real o Ys_d) /\ measurable_CDF p (real o Ys_d) /\
          (!z.
             cond_density lborel lborel p (real o Zs_a) (real o Z) z f_zsz f_z
               f_condZ) /\ den_gt0_ninfinity f_zsz f_z f_condZ /\
        indep_var p lborel (real o Zs_d) lborel (real o Z) /\
        cont_CDF p (real o Zs_d) /\ measurable_CDF p (real o Zs_d) ==>
          (prob p
             (DRBD_event p
             (nR_AND
                (\i.
                     if i:num = 0 then R_WSP Y Ys_a Ys_d
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else R_WSP Z Zs_a Zs_d) {0:num; 1; 2}) t) = 
          (1 -
     (pos_fn_integral lborel
        (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y * f_y y *
             pos_fn_integral lborel
               (\x. indicator_fn {w | y < w /\ w <= t} x * f_condY y x)) +
      pos_fn_integral lborel
        (\y.
             f_y y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Ys_d) y)))) *
    (1 -
     (pos_fn_integral lborel
        (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y * f_z y *
             pos_fn_integral lborel
               (\x. indicator_fn {w | y < w /\ w <= t} x * f_condZ y x)) +
      pos_fn_integral lborel
        (\y.
             f_z y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Zs_d) y)))) *
    (1 -
     (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
     (1 - Normal (product L2 (\l. real (Rel p (X l) t)))))) ``,

RW_TAC std_ss [Rel_DRBD_SEN_plus]
THEN KNOW_TAC(``Rel p (R_WSP Y Ys_a Ys_d) t = (1 -
    (pos_fn_integral lborel
       (\y.
            indicator_fn {u | 0 <= u /\ u <= t} y * f_y y *
            pos_fn_integral lborel
              (\x. indicator_fn {w | y < w /\ w <= t} x * f_condY y x)) +
     pos_fn_integral lborel
       (\y.
            f_y y *
            (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Ys_d) y)))) ``)
     THEN1(`rv_gt0_ninfinity[Ys_a; Ys_d; Y]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN `(!s. ALL_DISTINCT [Ys_a s; Ys_d s; Y s])` by FULL_SIMP_TAC list_ss[ALL_DISTINCT]
           THEN METIS_TAC[Rel_R_WSP])
THEN KNOW_TAC(``Rel p (R_WSP Z Zs_a Zs_d) t = (1 -
     (pos_fn_integral lborel
        (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y * f_z y *
             pos_fn_integral lborel
               (\x. indicator_fn {w | y < w /\ w <= t} x * f_condZ y x)) +
      pos_fn_integral lborel
        (\y.
             f_z y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Zs_d) y)))) ``)

      THEN1(`rv_gt0_ninfinity[Zs_a; Zs_d; Z]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN `(!s. ALL_DISTINCT [Zs_a s; Zs_d s; Z s])` by FULL_SIMP_TAC list_ss[ALL_DISTINCT]
           THEN METIS_TAC[Rel_R_WSP])
THEN RW_TAC std_ss[]);

val _ = export_theory();

